diff --git a/common/flatpak-dir.c b/common/flatpak-dir.c
index 3710f1fc28..44b22b7b6b 100644
--- a/common/flatpak-dir.c
+++ b/common/flatpak-dir.c
@@ -6881,6 +6881,22 @@ apply_extra_data (FlatpakDir   *self,
   return TRUE;
 }
 
+/* We create a deploy ref for the currently deployed version of all refs to avoid
+   deployed commits being pruned when e.g. we pull --no-deploy. */
+static gboolean
+flatpak_dir_update_deploy_ref (FlatpakDir          *self,
+                               const char          *ref,
+                               const char          *checksum,
+                               GError             **error)
+{
+  g_autofree char *deploy_ref = g_strconcat ("deploy/", ref, NULL);
+
+  if (!ostree_repo_set_ref_immediate (self->repo, NULL, deploy_ref, checksum, NULL, error))
+    return FALSE;
+
+  return TRUE;
+}
+
 gboolean
 flatpak_dir_deploy (FlatpakDir          *self,
                     const char          *origin,
@@ -6921,6 +6937,7 @@ flatpak_dir_deploy (FlatpakDir          *self,
   g_auto(GLnxLockFile) lock = { 0, };
   g_autoptr(GFile) metadata_file = NULL;
   g_autofree char *metadata_contents = NULL;
+  g_autofree char *deploy_ref = NULL;
   g_auto(GStrv) ref_parts = NULL;
   gboolean is_app;
 
@@ -7315,6 +7332,9 @@ flatpak_dir_deploy (FlatpakDir          *self,
   if (!flatpak_dir_set_active (self, ref, checkout_basename, cancellable, error))
     return FALSE;
 
+  if (!flatpak_dir_update_deploy_ref (self, ref, checksum, error))
+    return FALSE;
+
   return TRUE;
 }
 
@@ -8639,6 +8659,9 @@ flatpak_dir_uninstall (FlatpakDir                 *self,
         }
     }
 
+  if (!flatpak_dir_update_deploy_ref (self, ref, NULL, error))
+    return FALSE;
+
   if (!flatpak_dir_undeploy_all (self, ref, force_remove, &was_deployed, cancellable, error))
     return FALSE;
 
